/**
  ******************************************************************************
  * @file    Project/PT32Z192xx_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2021/05/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include <stdio.h>

/** @addtogroup PT32Z192xx_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/



int dat_adc;
uint16_t ADC_SWGetValue(void)
{
	
	/***˲ãתʮѹֵȥߺֵȡƽ****/
  uint8_t i;
  uint16_t PA_int_ADC_Data[10],PV_int_max,PV_int_min;
  uint32_t PV_long_temp=0;

  //ADCת                                       
  for(i=0;i<10;i++)
  {                                     
	/*ȴADCһת*/
	while(!ADC_GetFlagStatus(ADC,ADC_FLAG_EOC));
	/*ȡADCת*/
	PA_int_ADC_Data[i]=ADC_GetConversionValue(ADC);
	PV_long_temp+=PA_int_ADC_Data[i];
	/*תɱʶλ*/	
	ADC_ClearFlag(ADC,ADC_FLAG_EOC);
  }                                          
	/*жСֵ*/
  PV_int_max=PA_int_ADC_Data[0];
  PV_int_min=PA_int_ADC_Data[0];
  for(i=0;i<10;i++)                          
  { 
	if(PA_int_ADC_Data[i]>PV_int_max)
	  PV_int_max=PA_int_ADC_Data[i]; 
	if(PA_int_ADC_Data[i]<PV_int_min)
	  PV_int_min=PA_int_ADC_Data[i];
  }                                             

  //ת
  return((PV_long_temp-PV_int_max-PV_int_min)/8);
}
void UART_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB10ΪUART2_TX,PB11ΪUART2_RX*/
	GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource10,GPIO_AF_1);
	GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource11,GPIO_AF_1);
	GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_11,ENABLE);
	GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_10,ENABLE);
	/*ʼUART2*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D_P;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
	UART_InitStruct.FCPU = 24000000;
  UART_Init(UART2, &UART_InitStruct);
	/*UART2շ*/		
  UART_Cmd(UART2, ENABLE);
}
	void Delay(int Count)
{
  while(Count--);
}

int main(void)
{
  uint16_t adc_result=0x00;

	ADC_InitTypeDef  ADC_InitStruct;

	/*UARTܴ򿪣ڴӡADCתĵѹ*/	
	UART_Config();
	/*PC3ģͨADCʹ*/
  ADC_ChannelConfig(ADC,ADC_Channel_3);

	/*ADCĳʼ(ת)*/
	ADC_InitStruct.ADC_ConvMode = ADC_ConvMode_Continue ;
	ADC_InitStruct.ADC_Resolution = ADC_Resolution_12bit;
	ADC_InitStruct.ADC_ClkDiv = 0xFF;
	ADC_InitStruct.ADC_ChSel = ADC_ChSel_3;
	ADC_Init(ADC, &ADC_InitStruct);
	/*ADC蹦*/
  ADC_Cmd(ADC, ENABLE);
	/*ADCת*/
	ADC_StartOfConversion(ADC);
  while (1)
  {
	/*ADCתģʽ£תѹ*/
  adc_result = 	ADC_SWGetValue();
  printf("\r\nѹ=%x",adc_result);
  }
 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  while (1)
  {

  }
}
#endif

/**
  * @}
  */



