/**
  ******************************************************************************
  * @file    Project/PT32Z192xx_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2021/05/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stdio.h"
#define Master_SPIx  SPI0

uint16_t i,ge[8],j,mode[4]={0x00,0x01,0x11,0x10};
uint8_t sof_hard;
SPI_InitTypeDef  SPI_InitStructure;


void Handshake_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;	
		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
    GPIO_InitStructure.GPIO_PuPd=GPIO_PuPd_NOPULL;
		/*ÿ⺯ʼGPIO*/
		GPIO_Init(CMSDK_PC, &GPIO_InitStructure);
    /*PC3*/	
	  GPIO_SetBits(CMSDK_PC, GPIO_Pin_3);
}



void UART_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB10ΪUART2_TX,PB11ΪUART2_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource11, GPIO_AF_1);
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource10, GPIO_AF_1);
  GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_11,ENABLE);
	GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_10,ENABLE);
	/*ʼUART2*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D_P;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
	UART_InitStruct.FCPU = 24000000;
  UART_Init(UART2, &UART_InitStruct);
	/*UART2շ*/		
  UART_Cmd(UART2, ENABLE);
}




void Soft_Master_Test(void)
{
	uint8_t i;
			/*ģʽ00ģʽ01*/
	 	printf("\r\n\r\n()Master(mode=%x)",mode[j]);
		if(j==0 ||j==1 )
		{
			GPIO_SetBits(CMSDK_PC, GPIO_Pin_3);             //MasterFIFOͷFIFOΪ
			while(GPIO_ReadInputDataBit(CMSDK_PB,GPIO_Pin_2)!=Bit_SET);
			GPIO_ResetBits(CMSDK_PC, GPIO_Pin_3);
	    for(i=0;i<8;i++)
				{	
				SPI_NSSInternalSoftwareConfig(Master_SPIx,SPI_NSSInternalSoft_Reset);  //CS
				SPI_SendData(Master_SPIx,i);	//ݼĴдֵ
				while(SPI_GetFlagStatus(Master_SPIx,SPI_FLAG_BUSY));      //ȴ״̬
				SPI_NSSInternalSoftwareConfig(Master_SPIx,SPI_NSSInternalSoft_Set);   //CS	
				}
				while(!SPI_GetFlagStatus(Master_SPIx,SPI_FLAG_RFF));     //ȴMasterFIFOȫ
				while(GPIO_ReadInputDataBit(CMSDK_PB,GPIO_Pin_2));    //ȴSlaveδ
		    for(i=0;i<8;i++)
				{
					ge[i]=SPI_ReceiveData(Master_SPIx);
					printf("%x ",ge[i]);
				 //Masterֵ
					if(ge[i]!=i+8)
					{
						printf("error");
						while(1);
					}
				}
		}
		/*ģʽ11ģʽ10*/
		else if(j==2 ||j==3)
		{
			GPIO_SetBits(CMSDK_PC, GPIO_Pin_3);             //MasterFIFOͷFIFOΪ
			while(GPIO_ReadInputDataBit(CMSDK_PB,GPIO_Pin_2)!=Bit_SET);    //ȴSlaveFIFOȫ	
			SPI_NSSInternalSoftwareConfig(Master_SPIx,SPI_NSSInternalSoft_Reset);  //CS
			GPIO_ResetBits(CMSDK_PC, GPIO_Pin_3);
			for(i=0;i<8;i++)
					{	
           SPI_SendData(Master_SPIx,i);    //ݼĴдֵ
					 }
			while(!SPI_GetFlagStatus(Master_SPIx,SPI_FLAG_RFF));     //ȴMasterFIFOȫ
	    while(SPI_GetFlagStatus(Master_SPIx,SPI_FLAG_BUSY));      //ȴ״̬  
			while(GPIO_ReadInputDataBit(CMSDK_PB,GPIO_Pin_2));    //ȴSlaveδ
			SPI_NSSInternalSoftwareConfig(Master_SPIx,SPI_NSSInternalSoft_Set);   //CS	

			for(i=0;i<8;i++)
			{
						ge[i]=SPI_ReceiveData(Master_SPIx);
						printf("%x ",ge[i]);
				 //Masterֵ
					if(ge[i]!=i+8)
					{
						printf("error");
						while(1);
					}
			}
		}	
	
}

void Hard_Master_Test(void)
{
  printf("\r\n\r\n(Ӳ)Master(mode=%x)",mode[j]);
	
		/*Ӳģʽ00/01/11/10*/
  GPIO_SetBits(CMSDK_PC, GPIO_Pin_3);
	while(GPIO_ReadInputDataBit(CMSDK_PB,GPIO_Pin_2)!=Bit_SET);    //ȴSlaveFIFOȫ	
  CMSDK_PC->DATA=0x00;	 
	for(i=0;i<8;i++)
	{	
	   SPI_SendData(Master_SPIx,i);    //ݼĴдֵ
	 }
	 while(!SPI_GetFlagStatus(Master_SPIx,SPI_FLAG_RFF));     //ȴMasterFIFOȫ
	 while(SPI_GetFlagStatus(Master_SPIx,SPI_FLAG_BUSY));      //ȴ״̬  
	 
  for(i=0;i<8;i++)
	{
				ge[i]=SPI_ReceiveData(Master_SPIx);
		    printf("%x ",ge[i]);
		 //Masterֵ
		  if(ge[i]!=i+8)
			{
				printf("error");
				while(1);
			}
	}
}

int main()
{
	/*ʹӻPB2,PC3...SPIĸҲ*/
  Handshake_GPIO_Config();
	/*UARTʼ*/
	UART_Config( );
	printf("Master mode");
	printf("Ӳģʽѡ0  /  ģʽѡ1\r\n");
	sof_hard=getchar()-0x30;
	printf("%d\r\n",sof_hard);
	/*SPIŸ*/
//		GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource12,GPIO_AF_1);
//		GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource13,GPIO_AF_1);
//		GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource14,GPIO_AF_1);
//		GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource15,GPIO_AF_1);
	  GPIO_PinAFConfig(CMSDK_PA,GPIO_PinSource4,GPIO_AF_1);
    GPIO_PinAFConfig(CMSDK_PA,GPIO_PinSource5,GPIO_AF_1);
    GPIO_PinAFConfig(CMSDK_PA,GPIO_PinSource6,GPIO_AF_1);
    GPIO_PinAFConfig(CMSDK_PA,GPIO_PinSource7,GPIO_AF_1);
	while(1)
	 {
		 for(j=0;j<4;j++)
			{
		SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
		SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
		SPI_InitStructure.SPI_CPOL = (mode[j]&0x01)<<6; 
		SPI_InitStructure.SPI_CPHA = (mode[j]&0x10)<<3;
		SPI_InitStructure.SPI_NSS = sof_hard<<2;    //  Ӳ ģʽѡ
		SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_128;
		SPI_InitStructure.SPI_BaudRatePostPrescaler = 10;
		SPI_Init(Master_SPIx , &SPI_InitStructure);
		/*ʹMaster_SPI*/
		SPI_Cmd(Master_SPIx , ENABLE);
    /******SPIģʽ******/
		if(sof_hard==1)
       Soft_Master_Test();
		else if(sof_hard==0)
	     Hard_Master_Test();
		
		}
	}			
}
#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  while (1)
  {

  }
}
#endif

/**
  * @}
  */



