/**
  ******************************************************************************
  * @file    Project/PT32Z192xx_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2021/05/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stdio.h"
/** @addtogroup PT32Z192xx_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
#define            ADVANCE_TIM_PERIOD            (1000-1)
#define            ADVANCE_TIM_PSC               (24-1)

uint32_t time = 0; 
	
	void Delay(int Count)
{
  while(Count--);
}

void LED_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED1_GPIO_PIN;	

		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED1_GPIO_PORT, &GPIO_InitStructure);	
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED2_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED2_GPIO_PORT, &GPIO_InitStructure);
		
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = LED3_GPIO_PIN;

		/*ÿ⺯ʼGPIO*/
		GPIO_Init(LED3_GPIO_PORT, &GPIO_InitStructure);

		/* رled	*/
		GPIO_SetBits(LED1_GPIO_PORT, LED1_GPIO_PIN);
		
		/* رled	*/
		GPIO_SetBits(LED2_GPIO_PORT, LED2_GPIO_PIN);	 
    
    /* رled	*/
		GPIO_SetBits(LED3_GPIO_PORT, LED3_GPIO_PIN);
}

static void TIMER_Mode_Config(void)
{
  TIM_TimeBaseInitTypeDef TimeBaseInit;
	NVIC_InitTypeDef NVIC_InitStruct;
  /*ʹTIMER0NVIC*/
  NVIC_InitStruct.NVIC_IRQChannel = TMR3_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);

	/* CNTʱ = Fcksys/(psc+1)*/
	TimeBaseInit.Prescaler = ADVANCE_TIM_PSC;      //24ԤƵ
	/*ģʽΪϼ*/
	/*ƥĴ,ۼMR0+1Ƶʺһ»ж*/
	TimeBaseInit.MatchValue = ADVANCE_TIM_PERIOD;    //10000װ
	/*CountMR0,λ*/
	TimeBaseInit.OVRSTEN = ENABLE;
	/*ʼʱ*/
  TIM_TimeBaseInit(TIM3, &TimeBaseInit);
	/*ʹܶʱTCؼĴMR0ƥʱж*/	
	TIM_ITConfig(TIM3, TIM_INT_MR0, ENABLE);	
  /**/	
	TIM_Cmd(TIM3, ENABLE);

}
int main(void)
{

  LED_GPIO_Config();
  /*ʼʱ*/
	TIMER_Mode_Config();
  /* Infinite loop */
	   
  while (1)
  {
    /* 1000 * 1000us = 1s ʱ䵽 */
    if ( time == 1000 ) 
    {
      time = 0;
//			/* LED3 ȡ */      
      LED3_TOGGLE; 				
    }        
   } 		 


}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */



