/**
  ******************************************************************************
  * @file    Project/PT32Z192xx_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2021/05/28
  * @brief   Main 
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  * 
  *
  * 
  * 
  * 
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stdio.h"
#define Slave_SPIx SPI0


uint16_t ch[8],i,j,mode[4]={0x00,0x01,0x11,0x10};
uint8_t sof_hard;
SPI_InitTypeDef  SPI_InitStructure;


void UART_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB10ΪUART2_TX,PB11ΪUART2_RX*/
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource11, GPIO_AF_1);
  GPIO_PinAFConfig(CMSDK_PB, GPIO_PinSource10, GPIO_AF_1);
  GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_11,ENABLE);
	GPIO_PullUpConfig(CMSDK_PB,GPIO_Pin_10,ENABLE);
	/*ʼUART2*/
  UART_InitStruct.UART_BaudRate = 19200;
  UART_InitStruct.UART_WordLength = UARTM_8D_P;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_InitStruct.UART_SampleRate = UART_SAMPLERATEX16;
	UART_InitStruct.FCPU = 24000000;
  UART_Init(UART2, &UART_InitStruct);
	/*UART2շ*/		
  UART_Cmd(UART2, ENABLE);
}

void Handshake_GPIO_Config(void)
{		
		/*һGPIO_InitTypeDef͵Ľṹ*/
		GPIO_InitTypeDef GPIO_InitStructure;
		/*ѡҪƵGPIO*/
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;	
		/*ģʽΪͨ*/
		GPIO_InitStructure.GPIO_Mode = GPIO_OType_PP;   
    GPIO_InitStructure.GPIO_PuPd=GPIO_PuPd_NOPULL;
		/*ÿ⺯ʼGPIO*/
		GPIO_Init(CMSDK_PB, &GPIO_InitStructure);
    /*PB2*/	
	  GPIO_ResetBits(CMSDK_PB, GPIO_Pin_2);
}


void Soft_Slave_Test(void)
{
	printf("\r\n\r\n()Slave_SPI(mode=%x)",mode[j]);
	  /*ȴSlaveȫ*/
	  while(!SPI_GetFlagStatus(Slave_SPIx,SPI_SR_TFE));
    /*ȴSlaveȫ*/	
	  while(SPI_GetFlagStatus(Slave_SPIx,SPI_SR_RFNE)); 
    /*PB2*/	
		GPIO_ResetBits(CMSDK_PB, GPIO_Pin_2);
	  /*ȴMasterΪգΪ,PC3*/
	  while(!GPIO_ReadInputDataBit(CMSDK_PC,GPIO_Pin_3));   
	  SPI_SendData(Slave_SPIx,8);	
	  SPI_SendData(Slave_SPIx,9);	
	  SPI_SendData(Slave_SPIx,10);	
	  SPI_SendData(Slave_SPIx,11);	
	  SPI_SendData(Slave_SPIx,12);	
	  SPI_SendData(Slave_SPIx,13);	
	  SPI_SendData(Slave_SPIx,14);	
	  SPI_SendData(Slave_SPIx,15);
	  /*ȴFIFOȫ*/
	  while(SPI_GetFlagStatus(Slave_SPIx,SPI_FLAG_TFNF));
		GPIO_SetBits(CMSDK_PB, GPIO_Pin_2);
	  while(!SPI_GetFlagStatus(Slave_SPIx,SPI_FLAG_TFNF));  
	  GPIO_ResetBits(CMSDK_PB, GPIO_Pin_2);
		/*ȴMasterPC3*/
		while(GPIO_ReadInputDataBit(CMSDK_PC,GPIO_Pin_3)); 
    /*ȴSlaveȫ*/	
	  while(!SPI_GetFlagStatus(Slave_SPIx,SPI_FLAG_RFF));  
		/*Slaveֵ*/
	  for(i=0;i<8;i++)
	  {
		ch[i]= SPI_ReceiveData(Slave_SPIx);      
		printf("%x ",ch[i]);   
			if(ch[i]!=i)
			{
				printf("error");
				while(1);
			}	
    }
}


void Hard_Slave_Test(void)
{
		/*PB2*/
		GPIO_ResetBits(CMSDK_PB, GPIO_Pin_2);
		/*ȴPC3*/
		while(!GPIO_ReadInputDataBit(CMSDK_PC,GPIO_Pin_3));   
		SPI_SendData(Slave_SPIx,8);	
		SPI_SendData(Slave_SPIx,9);	
		SPI_SendData(Slave_SPIx,10);	
		SPI_SendData(Slave_SPIx,11);	
		SPI_SendData(Slave_SPIx,12);	
		SPI_SendData(Slave_SPIx,13);	
		SPI_SendData(Slave_SPIx,14);	
		SPI_SendData(Slave_SPIx,15);	
		
		printf("\r\n\r\n(Ӳ)Slave_SPI(mode=%x)",mode[j]);
		/*ȴFIFOȫ*/
		while(SPI_GetFlagStatus(Slave_SPIx,SPI_FLAG_TFNF));
		/*ӻPD2*/
		GPIO_SetBits(CMSDK_PB, GPIO_Pin_2);        
	  while(!SPI_GetFlagStatus(Slave_SPIx,SPI_FLAG_TFNF));   
		GPIO_ResetBits(CMSDK_PB, GPIO_Pin_2);
		/*ȴSlaveȫ*/
		while(!SPI_GetFlagStatus(Slave_SPIx,SPI_FLAG_RFF));  
		
		/*Slaveֵ*/
		for(i=0;i<8;i++)
		{
			ch[i]= SPI_ReceiveData(Slave_SPIx);      
			printf("%x ",ch[i]);   
			if(ch[i]!=i)
			{
				printf("error");
				while(1);
			}
		}
								
}


int main()
{

 /*ʹӻPB2,PC3*/
  Handshake_GPIO_Config();
	/*UARTʼ*/
	UART_Config( );
	printf("Slave mode\r\n");
	CMSDK_SYSCON->RSTINFO=CMSDK_SYSCON->RSTINFO;
	printf("Ӳģʽѡ0  /  ģʽѡ1\r\n");
	sof_hard=getchar()-0x30;
	printf("%d\r\n",sof_hard);

	/*SPIŸ*/
//	GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource12,GPIO_AF_2);
//  GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource13,GPIO_AF_2);
//  GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource14,GPIO_AF_2);
//  GPIO_PinAFConfig(CMSDK_PB,GPIO_PinSource15,GPIO_AF_2);
		GPIO_PinAFConfig(CMSDK_PA,GPIO_PinSource4,GPIO_AF_2);
    GPIO_PinAFConfig(CMSDK_PA,GPIO_PinSource5,GPIO_AF_2);
    GPIO_PinAFConfig(CMSDK_PA,GPIO_PinSource6,GPIO_AF_2);
    GPIO_PinAFConfig(CMSDK_PA,GPIO_PinSource7,GPIO_AF_2);
	while(1)
  {
   for(j=0;j<4;j++)
		{

			SPI_InitStructure.SPI_Mode = SPI_Mode_Slave;
			SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
			SPI_InitStructure.SPI_CPOL = (mode[j]&0x01)<<6; 
			SPI_InitStructure.SPI_CPHA = (mode[j]&0x10)<<3;
			SPI_InitStructure.SPI_NSS = sof_hard<<2;    //  Ӳģʽѡ
		SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_128;
		SPI_InitStructure.SPI_BaudRatePostPrescaler = 10;
			SPI_Init(Slave_SPIx, &SPI_InitStructure);	
			/* ʹ Slave_SPI */
			SPI_Cmd(Slave_SPIx , ENABLE);	 
			/***ģʽշ****/
      if(sof_hard==1)
     			Soft_Slave_Test();
			/***Ӳģʽշ***/
			else if(sof_hard==0)
	        Hard_Slave_Test();

	 }

		}
	

}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  while (1)
  {

  }
}
#endif

/**
  * @}
  */


